#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include "tools.h"

RGB picture[100][100];

int GetSimilar(RGB pixel)
{
    int n(0);
    int Max(1024);
    RGB comparer;

    for(int i=0;i<=15;i++)
    {
        int total(0);
        comparer.colorcode=ComparePalette[i];
        total+=abs(comparer.R()-pixel.R());
        total+=abs(comparer.G()-pixel.G());
        total+=abs(comparer.B()-pixel.B());
        if(total<=Max)
        {
            Max=total;
            n=i;
        }
    }

    return n;
}

int SavePicture(void)
{
    struct time t;
    struct date d;
    char buffer[256];

    gettime(&t);
    getdate(&d);

    wsprintf(buffer,".\\pictures\\%04d-%02d-%02d %02d-%02d-%02d.bmp",
      d.da_year,d.da_mon,d.da_day,
      t.ti_hour,t.ti_min,t.ti_sec);

    FILE *out;

    if((out=fopen(buffer, "wb"))== NULL)
    {
        mkdir(".\\pictures");
        if((out=fopen(buffer, "wb"))== NULL)return(0);
    }

    unsigned char bmphead[54] =
      {'B','M',198,20,0,0,0,0,0,0,'v',0,0,0,
      '(',0,0,0,'d',0,0,0,'d',0,0,0,1,0,4,0,
      0,0,0,0,80,20,0,0,196,14,0,0,196,14,0,0,
      0,0,0,0,0,0,0,0};

    fwrite(&bmphead,54,1,out);

    for(int i=0;i<=15;i++)
    {
        fwrite(&ColorPalette[i],4,1,out);
    }

    for(int y=99;y>=0;y--)
    {
        for(int x=0;x<=99;x+=2)
        {
            unsigned char putdata;
            putdata=GetSimilar(picture[x][y])*16;
            putdata+=GetSimilar(picture[x+1][y]);
            fwrite(&putdata,1,1,out);
        }
        char tmp(0);
        fwrite(&tmp,1,2,out);
    }

    fclose(out);
    return 0;
}

VOID CALLBACK TimerProc(HWND  hwnd,UINT  uMsg,UINT  idEvent,DWORD  dwTime)
{
    POINT point;
    GetCursorPos(&point);

    HDC MyDc;
    MyDc=GetDC(0);

    for(int y=0;y<=99;y++)
    {
        for(int x=0;x<=99;x++)
        {
            picture[x][y].colorcode =
            GetPixel(MyDc,point.x-50+x,point.y-50+y);
        }
    }

    ReleaseDC(0,MyDc);
    SavePicture();
}

int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    SetTimer(0,0,30000,TimerProc);

    MSG msg;

    while (GetMessage(&msg,NULL, 0, 0))
    {
        if (!TranslateAcceleratorA(msg.hwnd,NULL, &msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    KillTimer(0,0);
    return 0;
}
